<?php

namespace FiloBlu\Flow\Model\Actions\From;

class Addupsell {

    CONST ENTITY_TYPE_CODE = 'catalog_product';

    protected $_helper_product;
    protected $_model_product;
    /**
    * @var Monolog\Logger
    */
    protected $_logger;

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Product $helper_product,
        \FiloBlu\Flow\Helper\LoggerProvider $loggerProvider,
        \Magento\Catalog\Model\Product $model_product,
        array $data = []
    ) {
        $this->_helper_product = $helper_product;
        $this->_model_product = $model_product;
        $this->_logger = $loggerProvider->getLogger();
    }

    public static function process($product, $value, $storeId) {
        
        $model_product = \Magento\Framework\App\ObjectManager::getInstance()->create('\Magento\Catalog\Model\Product');     
        $logger = \Magento\Framework\App\ObjectManager::getInstance()->create('\FiloBlu\Flow\Helper\LoggerProvider')->getLogger();
        
        // $logger->info(__METHOD__);


        if (empty($value)) {
            return true;
        }

        \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Store\Model\StoreManagerInterface')->setCurrentStore($storeId);
        if ($storeId != 0) {
            return "The function is avalaible only for the ADMIN store.";
        }

        $_upsell = array();

        // controllo se si tratta di più upsell con separatore |
        $_upsell_sku = array();
        if(strrpos($value, '|')) {
            $_upsell_sku = explode( '|', $value);
        } else {
            $_upsell_sku[] = $value;
        }
        if(is_array($_upsell_sku) && count($_upsell_sku)>=1) {

            $linkDataAll = array();

            foreach($_upsell_sku as $_upsell) {
            
          
                //check first if the product exist
                $linkedProduct = $model_product->getIdBySku($_upsell);
                if($linkedProduct) {
                   /** @var  \Magento\Catalog\Api\Data\ProductLinkInterface $productLinks */
                   $productLinks = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Api\Data\ProductLinkInterface');
                   $linkData = $productLinks
                       ->setSku($product->getSku())
                       ->setLinkedProductSku($_upsell)
                       ->setLinkType("upsell");
                   $linkDataAll[] = $linkData;
               }

            }

            if($linkDataAll) {
                $product->setProductLinks($linkDataAll);
            }
         $product->save();

        }


        // mettere in configurazione se i upsell devono essere salvati anche su configurabile - default YES
        if ($product->getTypeId() == \Magento\Catalog\Model\Product\Type::DEFAULT_TYPE) {
            $parentIds = \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\ConfigurableProduct\Model\ResourceModel\Product\Type\Configurable')
                ->getParentIdsByChild($product->getId());
            if (count($parentIds) <= 0)
                return true;

            foreach ($parentIds as $parentId) {
                $parent_product = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')->load($parentId);

                if(is_array($_upsell_sku) && count($_upsell_sku)>=1) {

                    $linkDataAll = array();

                    foreach($_upsell_sku as $_upsell) {

                       //check first if the product exist
                        $linkedProduct = $model_product->getIdBySku($_upsell);
                        if($linkedProduct) {
                           /** @var  \Magento\Catalog\Api\Data\ProductLinkInterface $productLinks */
                           $productLinks = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Api\Data\ProductLinkInterface');
                           $linkData = $productLinks
                               ->setSku($parent_product->getSku())
                               ->setLinkedProductSku($_upsell)
                               ->setLinkType("upsell");
                           $linkDataAll[] = $linkData;
                       }

                    }

                    if($linkDataAll) {
                        $parent_product->setProductLinks($linkDataAll);
                    }
                 $parent_product->save();

                }
            }

        }

    }

}
